#ifndef LABA_H
#define LABA_H

#include <QVector>
#include <QColor>
#include <QPolygonF>

/* Константы */

enum DataType {
	None,
	Points,
	Line,
	Loop
};

class MyElem
{
public:
	MyElem() : type(None) { }
	MyElem(DataType t, QColor c, QPolygonF p) : type(t), color(c), polygon(p) { }
	DataType type;
	QColor color;
	QPolygonF polygon;
};

/* Шаблон всех лаб */

class Laba
{
public:
	virtual const char *name() const = 0;
	virtual void generate() = 0;
	virtual const QVector<MyElem> &data() const;
protected:
	QVector<MyElem> _data;
};

/* Все лабы */

class Problem8 : public Laba
{
public:
	Problem8();
	const char *name() const;
	void generate();
};

class Problem17 : public Laba
{
public:
	Problem17();
	const char *name() const;
	void generate();
};

class Problem28 : public Laba
{
public:
	Problem28();
	const char *name() const;
	void generate();
};

#endif // LABA_H
