#include "widget.h"
#include "ui_widget.h"

#include "laba.h"

Widget::Widget(QWidget *parent) : QWidget(parent), ui(new Ui::Widget)
{
	// Инициализация лабораторных
	labas << new Problem8;
	labas << new Problem17;
	labas << new Problem28;

	// Инициализируем интерфейс
	ui->setupUi(this);

	// Заполняем список лаб
	foreach (Laba *laba, labas)
		new QListWidgetItem(tr(laba->name()), ui->list);

	// Устанавливаем текущее значение списка
	ui->list->setCurrentRow(0);
}

Widget::~Widget()
{
	foreach (Laba *laba, labas)
		delete laba;

	delete ui;
}

void Widget::labaPicked(int current)
{
	// Отладочная информация
	qDebug("Choosed laba number %i", current);

	// Проверяем, чтобы current оказался в допустимом диапазоне
	if ((current < 0) || (current >= labas.count())) {
		qDebug("Wrong laba's number!");
		return;
	}

	// Устанавливаем текущую лабу
	ui->gl->laba = labas[current];
	ui->gl->update();

	// Делаем активной кнопку генерации примеров
	ui->generate->setEnabled(true);
}

void Widget::generate()
{
	// Отладочная информация
	qDebug("Generator called.");

	// Генерируем новый пример для текущей задачи
	int current = ui->list->currentRow();
	labas[current]->generate();
	ui->gl->update();
}

void Widget::setZoom(int zoom)
{
	ui->gl->setZoom(zoom / 30.0f);
	ui->gl->update();
}
